﻿' Namespaces importieren, um den Code übersichtlicher zu gestalten
Imports System.IO
Imports System.Web.Services.Protocols
Imports System.Data.SqlClient

' die Referenz zum Berichtsserver importieren
Imports BerichtErstellenUndWeitergeben.Berichtsserver

Public Class frmBenutzeroberfläche

    ' Globale Variablen und Konstanten
    Dim _sRdl As String
    Dim _ds As New DataSet
    Dim _sDataSourceName As String = "meineDatenquelle"
    Dim _sqlDataAdapter As SqlDataAdapter = New SqlDataAdapter

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Private Sub lblSqlAnweisung_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lblSqlAnweisung.Click

    End Sub


    Private Sub generiereBerichtsdefinition()
        ' RDL-String erstellen, der mit Hilfe der Methode writeFile() in 
        ' eine Datei geschrieben wird
        Windows.Forms.Cursor.Current = Cursors.WaitCursor

        ' Daten holen
        getData()
        ' _sRdl ist der String, der den RDL-Code enthält. Er beginnt mit einem 
        ' Standardkopf und wird dynamisch in Abhängigkeit von den Daten, 
        ' für die die Berichtsdefinition generiert wird, zusammengefügt.
        ' Datenquelle festlegen Tabellen- und Header-Definition öffnen
        _sRdl = "<?xml version=""1.0"" encoding=""utf-8""?>" + _
                "<Report xmlns= ""http://schemas.microsoft.com/sqlserver/reporting" + _
                "/2005/01/reportdefinition"" xmlns:rd=""http://schemas.microsoft" + _
                ".com/SQLServer/reporting/reportdesigner"">" + _
                  "<DataSources>" + _
                    "<DataSource Name=""" + _sDataSourceName + """>" + _
                      "<ConnectionProperties>" + _
                        "<DataProvider>SQL</DataProvider>" + _
                        "<ConnectString>" + tbxSqlVerbindung.Text + _
                        "</ConnectString>" + _
                        "<IntegratedSecurity>true</IntegratedSecurity>" + _
                      "</ConnectionProperties>" + _
                    "</DataSource>" + _
                  "</DataSources>"
        _sRdl = _sRdl + _
                  "<Body>" + _
                    "<ReportItems>" + _
                      "<Table Name=""table1"">" + _
                        "<Style />"
        _sRdl = _sRdl + _
                                "<Header>" + _
                                  "<TableRows>" + _
                                    "<TableRow>" + _
                                      "<Height>0.48552cm</Height>" + _
                                      "<TableCells>" + Chr(10)
        Dim column As DataColumn
        Dim i As Int16

        ' Spaltenüberschrift zusammensetzen
        For Each column In _ds.Tables(0).Columns
            ' Alle Spalten (außer der rowguid-Spalte, die in Berichten sehr unschön
            ' aussieht) werden in den Bericht übernommen
            If Not column.ColumnName = "rowguid" Then
                _sRdl = _sRdl + _
                                "<TableCell>" + _
                                  "<ReportItems>" + _
                                    "<Textbox Name=""textbox" + i.ToString + """>" + _
                                      "<Style>" + _
                                        "<FontWeight>900</FontWeight>" + _
                                        "<BorderStyle>" + _
                                          "<Default>Solid</Default>" + _
                                        "</BorderStyle>" + _
                                      "</Style>" + _
                                      "<Value>" + column.ColumnName + "</Value>" + _
                                    "</Textbox>" + _
                                  "</ReportItems>" + _
                                "</TableCell>" + Chr(10)
            End If
            i = i + 1
        Next
        'Header abschließen
        _sRdl = _sRdl + _
                              "</TableCells>" + _
                            "</TableRow>" + _
                          "</TableRows>" + _
                        "</Header>"
        _sRdl = _sRdl + _
                        "<Details>" + _
                          "<TableRows>" + _
                            "<TableRow>" + _
                              "<Height>0.48552cm</Height>" + _
                              "<TableCells>"

        ' Tabellenzellen zusammensetzen
        For Each column In _ds.Tables(0).Columns
            ' Alle Spalten (außer der rowguid-Spalte, die in Berichten sehr unschön
            ' aussieht) werden in den Bericht übernommen
            If Not column.ColumnName = "rowguid" Then
                _sRdl = _sRdl + _
                                "<TableCell>" + _
                                  "<ReportItems>" + _
                                    "<Textbox Name=""textbox" + i.ToString + """>" + _
                                      "<Style>" + _
                                        "<BorderStyle>" + _
                                          "<Default>Solid</Default>" + _
                                        "</BorderStyle>" + _
                                      "</Style>" + _
                                      "<Value>=Fields!" + _
                                      column.ColumnName + ".Value</Value>" + _
                                    "</Textbox>" + _
                                  "</ReportItems>" + _
                                "</TableCell>" + Chr(10)
            End If
            i = i + 1
        Next

        'Details abschließen und Tabellenspaltenlayout einleiten
        _sRdl = _sRdl + _
                              "</TableCells>" + _
                            "</TableRow>" + _
                          "</TableRows>" + _
                        "</Details>"
        _sRdl = _sRdl + _
                        "<TableColumns>" + Chr(10)

        ' Spaltenlayout definieren
        For Each column In _ds.Tables(0).Columns
            ' Alle Spalten (außer der rowguid-Spalte, die in Berichten sehr unschön
            ' aussieht) werden in den Bericht übernommen
            If Not column.ColumnName = "rowguid" Then
                _sRdl = _sRdl + _
                          "<TableColumn>" + _
                            "<Width>4.00cm</Width>" + _
                          "</TableColumn>" + Chr(10)
            End If
        Next

        ' Spaltenlayout abschließen
        _sRdl = _sRdl + _
                        "</TableColumns>" + _
                      "</Table>" + _
                    "</ReportItems>" + _
                    "<Style />" + _
                    "<Height>1cm</Height>" + _
                  "</Body>" + _
                  "<Width>16cm</Width>"
        _sRdl = _sRdl + _
                  "<DataSets>" + _
                    "<DataSet Name=""DataSet1"">" + _
                      "<Fields>" + Chr(10)
        ' Zuweisung von Namen und Datentypen den Spaltenfeldern aus dem Dataset
        For Each column In _ds.Tables(0).Columns
            ' Alle Spalten (außer rowguid-Spalten, die in Berichten sehr unschön
            ' aussehen) in den Bericht übernehmen
            If Not column.ColumnName = "rowguid" Then
                _sRdl = _sRdl + _
                        "<Field Name=""" + column.ColumnName + """>" + _
                          "<DataField>" + column.ColumnName + "</DataField>" + _
                          "<rd:TypeName>" + column.DataType.ToString + _
                          "</rd:TypeName>" + _
                        "</Field>" + Chr(10)
            End If
        Next
        _sRdl = _sRdl + _
                      "</Fields>"
        ' Name der Datenquelle und SQL-Anweisung übergeben und 
        ' Berichtsdefinition abschließen
        _sRdl = _sRdl + _
                      "<Query>" + _
                        "<DataSourceName>" + _sDataSourceName + "</DataSourceName>" + _
                        "<CommandText>" + tbxSqlAnweisung.Text + "</CommandText>" + _
                      "</Query>" + _
                    "</DataSet>" + _
                  "</DataSets>" + _
                "<rd:SnapToGrid>true</rd:SnapToGrid>" + _
              "</Report>"

        ' den String _sRdl in eine rdl-Datei schreiben
        writeFile()
        Windows.Forms.Cursor.Current = Cursors.Default
    End Sub 'generiereBerichtsdefinition

    Private Sub writeFile()
        ' Hilfsfunktion
        ' den in der Methode generiereBerichtsdefinition zusammengeführten
        ' String in eine rdl-Datei schreiben
        Dim stream As StreamWriter = New StreamWriter(tbxRdlSpeicherort.Text)
        stream.Write(_sRdl)
        stream.Close()
        MessageBox.Show("Datei " + tbxRdlSpeicherort.Text + " geschrieben.")
    End Sub 'writeFile

    Private Sub getData()
        ' Hilfsfunktion
        ' mit Hilfe der SQL-Anweisung Daten aus der Datenquelle holen

        Dim sqlSelectCommand As New SqlCommand
        Dim sqlConnection As New SqlConnection

        Try
            ' sqlVerbindung initialisieren und Daten in ein Dataset laden
            sqlSelectCommand.CommandText = tbxSqlAnweisung.Text
            sqlConnection.ConnectionString = tbxSqlVerbindung.Text
            sqlSelectCommand.Connection = sqlConnection
            _sqlDataAdapter.SelectCommand = sqlSelectCommand
            _sqlDataAdapter.Fill(_ds)
        Catch e As SqlException
            'im Fehlerfall die Fehlermeldung anzeigen
            MessageBox.Show(e.Message)
        End Try
    End Sub 'getData

    Private Sub btnRdlErstellen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRdlErstellen.Click
        generiereBerichtsdefinition()
    End Sub

    Private Sub btnWeitergeben_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWeitergeben.Click
        ' im lokalen Dateisystem abgelegte Berichtsdefinition 
        ' an Berichtsserver weitergeben
        Windows.Forms.Cursor.Current = Cursors.WaitCursor
        Dim rs As New ReportingService2005
        rs.Credentials = System.Net.CredentialCache.DefaultCredentials

        'Initialisieren der Parameter für die Methode zum Weitergeben
        Dim definition As [Byte]() = Nothing
        Dim warnings As Warning() = Nothing
        Dim name As String = tbxBerichtname.Text

        Try
            ' die RDL-Datei aus lokalem Dateisystem einlesen
            Dim stream As FileStream = File.OpenRead(tbxRdlSpeicherort.Text)
            definition = New [Byte](stream.Length) {}
            stream.Read(definition, 0, CInt(stream.Length))
            stream.Close()

            ' Ausgeben einer Fehlermeldung, wenn Datei lesen fehlschlägt
        Catch eIO As IOException
            Console.WriteLine(eIO.Message)
        End Try
        Try
            ' Berichtsgenerierung aus Berichtsdefinition, Rückgabe und Speichern
            ' eventueller Warnungen und Fehler
            warnings = rs.CreateReport(name, tbxServerSpeicherort.Text, True, _
                definition, Nothing)

            ' bei Erfolg Meldung ausgeben
            MessageBox.Show("Bericht wurde erfolgreich weitergegeben.")

        Catch eSOAP As SoapException
            ' falls Weitergabe fehlschlägt, Fehlermeldung ausgegeben
            MessageBox.Show("Bericht konnte nicht weitergegeben werden: " + eSOAP. _
                Detail.InnerXml.ToString())
            Windows.Forms.Cursor.Current = Cursors.Default
        Catch exc As Exception
            MessageBox.Show(exc.Message)
        End Try

        Windows.Forms.Cursor.Current = Cursors.Default
    End Sub 'btnWeitergeben_Click

End Class
